using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace ReflectionIT.DualList
{
	/// <summary>
	/// Summary description for DualListControl.
	/// </summary>
	public class DualListControl : System.Windows.Forms.UserControl
	{
		private System.Windows.Forms.Button buttonDelete;
		private System.Windows.Forms.Button buttonAdd;
		private System.Windows.Forms.ListBox listBoxSelected;
		private System.Windows.Forms.ListBox listBoxAvailable;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label1;

		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public DualListControl()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitializeComponent call

		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.buttonDelete = new System.Windows.Forms.Button();
			this.buttonAdd = new System.Windows.Forms.Button();
			this.listBoxSelected = new System.Windows.Forms.ListBox();
			this.listBoxAvailable = new System.Windows.Forms.ListBox();
			this.label2 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// buttonDelete
			// 
			this.buttonDelete.Location = new System.Drawing.Point(128, 48);
			this.buttonDelete.Name = "buttonDelete";
			this.buttonDelete.Size = new System.Drawing.Size(72, 23);
			this.buttonDelete.TabIndex = 5;
			this.buttonDelete.Text = "< Delete <";
			this.buttonDelete.Click += new System.EventHandler(this.buttonDelete_Click);
			// 
			// buttonAdd
			// 
			this.buttonAdd.Location = new System.Drawing.Point(128, 16);
			this.buttonAdd.Name = "buttonAdd";
			this.buttonAdd.Size = new System.Drawing.Size(72, 23);
			this.buttonAdd.TabIndex = 2;
			this.buttonAdd.Text = "> Add >";
			this.buttonAdd.Click += new System.EventHandler(this.buttonAdd_Click);
			// 
			// listBoxSelected
			// 
			this.listBoxSelected.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.listBoxSelected.Location = new System.Drawing.Point(208, 16);
			this.listBoxSelected.Name = "listBoxSelected";
			this.listBoxSelected.Size = new System.Drawing.Size(120, 95);
			this.listBoxSelected.TabIndex = 4;
			// 
			// listBoxAvailable
			// 
			this.listBoxAvailable.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left)));
			this.listBoxAvailable.Location = new System.Drawing.Point(0, 16);
			this.listBoxAvailable.Name = "listBoxAvailable";
			this.listBoxAvailable.Size = new System.Drawing.Size(120, 95);
			this.listBoxAvailable.TabIndex = 1;
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(208, 0);
			this.label2.Name = "label2";
			this.label2.TabIndex = 3;
			this.label2.Text = "Selected:";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(0, 0);
			this.label1.Name = "label1";
			this.label1.TabIndex = 0;
			this.label1.Text = "Available:";
			// 
			// DualListControl
			// 
			this.Controls.Add(this.buttonDelete);
			this.Controls.Add(this.buttonAdd);
			this.Controls.Add(this.listBoxSelected);
			this.Controls.Add(this.listBoxAvailable);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.label2);
			this.Name = "DualListControl";
			this.Size = new System.Drawing.Size(328, 112);
			this.ResumeLayout(false);

		}
		#endregion

		private void buttonAdd_Click(object sender, System.EventArgs e) {
			ListBoxHelper.SwitchItem(listBoxAvailable, listBoxSelected);
		}

		private void buttonDelete_Click(object sender, System.EventArgs e) {
			ListBoxHelper.SwitchItem(listBoxSelected, listBoxAvailable);
		}

		[DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		[Editor(
         "System.Windows.Forms.Design.ListControlStringCollectionEditor, System.Design", 
				typeof(System.Drawing.Design.UITypeEditor))]
		public ListBox.ObjectCollection ItemsAvailable {
			get {
				return listBoxAvailable.Items;
			}
		}

		[DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
		[Editor(
         "System.Windows.Forms.Design.ListControlStringCollectionEditor, System.Design", 
				typeof(System.Drawing.Design.UITypeEditor))]
		public ListBox.ObjectCollection ItemsSelected {
			get {
				return listBoxSelected.Items;
			}
		}

		[DefaultValue("> Add >")]
		public string TextButtonAdd {
			get { return buttonAdd.Text; }
			set { buttonAdd.Text = value; }
		}

		[DefaultValue("< Delete <")]
		public string TextButtonDelete {
			get { return buttonDelete.Text; }
			set { buttonDelete.Text = value; }
		}

	}
}
