using System;
using System.Windows.Forms;

namespace ReflectionIT.DualList
{
	public sealed class ListBoxHelper {

		/// <summary>
		/// Utility classes are sealed and have a private constructor
		/// </summary>
		private ListBoxHelper() {} 

		public static void SwitchItem(ListBox source, ListBox destination) {
			int index = source.SelectedIndex;
			if (index > -1) {
				destination.SelectedIndex = destination.Items.Add(source.SelectedItem);
				source.Items.RemoveAt(index);
				source.SelectedIndex = (index > source.Items.Count - 1) ? index - 1 : index;
			}
		}

	}
}
